<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: userDefaults.php,v 1.21 2000/12/21 03:09:30 kevin Exp $

include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-user", "/base/user/userDefaultsHandler.php");
$i18n = $factory->getI18n();

// get defaults
$defaults = $cceClient->getObject("System", array(), "UserDefaults");

$page = $factory->getPage();

$block = $factory->getPagedBlock("userDefaults");

$quota = $factory->getInteger(
			"maxDiskSpaceField", 
			($defaults["quota"] != -1 ? $defaults["quota"] : ""), 
			1, 1024000);
$quota->setOptional('silent');

$block->addFormField(
  $quota,
  $factory->getLabel("maxDiskSpaceFieldDefault")
);

$userNameGenMode = $factory->getMultiChoice("userNameGenMode", array("firstInitLast", "firstLastInit", "first", "last"));
if($defaults["userNameGenMode"] == "firstInitLast")
  $userNameGenMode->setSelected(0, true);
if($defaults["userNameGenMode"] == "firstLastInit")
  $userNameGenMode->setSelected(1, true);
else if($defaults["userNameGenMode"] == "first")
  $userNameGenMode->setSelected(2, true);
else if($defaults["userNameGenMode"] == "last")
  $userNameGenMode->setSelected(3, true);

if($i18n->getProperty("genUsername") == "yes"){
	$block->addFormField($userNameGenMode, $factory->getLabel("userNameGenField"));
}

$block->addButton($factory->getSaveButton($page->getSubmitAction()));
$block->addButton($factory->getCancelButton("/base/user/userList.php"));

$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>

<?php print($block->toHtml()); ?>

<?php print($page->toFooterHtml()); ?>
